using System;
using System.Drawing;

namespace System.Windows.Forms
{

    public class ComboBoxExItem : object
    {
        // forecolor: transparent = inherit
        private Color forecolor = Color.FromKnownColor(KnownColor.Transparent);
        private bool mark = false;
        private int imageindex = -1;
        private object tag = null;
        private string text = null;
        private int _Retract = 0;
        private string _stext;

        // constructors
        public ComboBoxExItem()
        {
        }

        public ComboBoxExItem(string Text)
        {
            text = Text;
            _stext = Text;
        }

        public ComboBoxExItem(int retract, string Text)
        {
            _Retract = retract;
            text = Text;
            _stext = Text;
        }

        public ComboBoxExItem(int retract, string Text, int ImageIndex)
        {
            _Retract = retract;
            text = Text;
            _stext = Text;
            imageindex = ImageIndex;
        }

        public ComboBoxExItem(int retract, string Text, int ImageIndex, object Tag)
        {
            _Retract = retract;
            text = Text;
            _stext = Text;
            imageindex = ImageIndex;
            tag = Tag;
        }

        public ComboBoxExItem(int retract, string Text, string stext, int ImageIndex, object Tag)
        {
            _Retract = retract;
            text = Text;
            _stext = stext;
            imageindex = ImageIndex;
            tag = Tag;
        }

        public ComboBoxExItem(int retract, string Text, int ImageIndex, bool Mark)
        {
            _Retract = retract;
            text = Text;
            _stext = Text;
            imageindex = ImageIndex;
            mark = Mark;
        }

        public ComboBoxExItem(int retract, string Text, int ImageIndex, bool Mark, Color ForeColor)
        {
            _Retract = retract;
            text = Text;
            _stext = Text;
            imageindex = ImageIndex;
            mark = Mark;
            forecolor = ForeColor;
        }

        public ComboBoxExItem(int retract, string Text, int ImageIndex, bool Mark, Color ForeColor, object Tag)
        {
            _Retract = retract;
            text = Text;
            _stext = Text;
            imageindex = ImageIndex;
            mark = Mark;
            forecolor = ForeColor;
            tag = Tag;
        }

        // forecolor
        public Color ForeColor
        {
            get
            {
                return forecolor;
            }
            set
            {
                forecolor = value;
            }
        }

        // image index
        public int ImageIndex
        {
            get
            {
                return imageindex;
            }
            set
            {
                imageindex = value;
            }
        }

        // mark (bold)
        public bool Mark
        {
            get
            {
                return mark;
            }
            set
            {
                mark = value;
            }
        }

        // tag
        public object Tag
        {
            get
            {
                return tag;
            }
            set
            {
                tag = value;
            }
        }

        // item text
        public string Text
        {
            get
            {
                return text;
            }
            set
            {
                text = value;
            }
        }

        public int Retract
        {
            get
            {
                return _Retract;
            }
            set
            {
                _Retract = value;
            }
        }

        public string sText
        {
            get
            {
                return _stext;
            }
            set
            {
                _stext = value;
            }
        }


        // ToString() should return item text
        public override string ToString()
        {
            return _stext;
        }
    }

}
