using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace LControl
{
    public partial class CommandTextBox : UserControl
    {
        private delegate void MT_AppendTextDelegate(string s);

        private Queue Args;
        private IntPtr MT_Handle;
        public EventHandler CommandChanged;
        private string _Prompt;
        private bool KeyEnter;
        private string ptext,_Command;
        private bool HandleTextChanged;
        private MT_AppendTextDelegate MT_AppendTextDele;

        public CommandTextBox()
        {
            InitializeComponent();
            Args = new Queue();
            CommandChanged = null;
            _Prompt = "";
            textBox.Text = "";
            ptext = "";
            _Command = "";
            HandleTextChanged = true;
            textBox.KeyDown += new KeyEventHandler(textBox_KeyDown);
            MT_AppendTextDele += new MT_AppendTextDelegate(this.AppendText);
        }

        private void textBox_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
                KeyEnter = true;
            else
                KeyEnter = false;
        }

        private void textBox_TextChanged(object sender, EventArgs e)
        {
            if (HandleTextChanged)
            {
                if (KeyEnter)
                {
                    KeyEnter = false;
                    ptext = textBox.Text + _Prompt;
                    HandleTextChanged = false;
                    textBox.Text += _Prompt;
                    textBox.SelectionStart = textBox.Text.Length;
                    if (CommandChanged != null) CommandChanged(this, new EventArgs());
                    _Command = "";
                }
                else
                {
                    if (String.Compare(ptext, 0, textBox.Text, 0, ptext.Length)==0)
                    {
                        _Command = textBox.Text.Substring(ptext.Length);
                    }
                    else
                    {
                        HandleTextChanged = false;
                        textBox.Text = ptext + _Command;
                        textBox.SelectionStart = textBox.Text.Length;
                    }
                }
            }
            else
                HandleTextChanged = true;
            textBox.ScrollToCaret();
        }

        public string Prompt
        {
            get { return _Prompt; }
            set
            {
                _Prompt=value;
                AppendText("\r\n");
            }
        }

        public void MT_AppendText(string text)
        {
            this.Invoke(this.MT_AppendTextDele, text);
        }

        public void AppendText(string Text)
        {
            ptext += Text + Prompt;
            HandleTextChanged = false;
            textBox.AppendText(Text + Prompt + _Command);
            textBox.SelectionStart = textBox.Text.Length;
            textBox.ScrollToCaret();
        }

        public string Command
        {
            get { return _Command; }
        }

        private void Menu_Clear_Click(object sender, EventArgs e)
        {
            ptext = _Prompt;
            _Command = "";
            HandleTextChanged = false;
            textBox.Text = _Prompt;
            textBox.SelectionStart = textBox.Text.Length;
        }

        private void Menu_Copy_Click(object sender, EventArgs e)
        {
            textBox.Copy();
        }

        private void Menu_Cut_Click(object sender, EventArgs e)
        {
            textBox.Cut();
        }

        private void Menu_Paste_Click(object sender, EventArgs e)
        {
            string s=Clipboard.GetText();
            Clipboard.SetText(s.Replace('\r', ' ').Replace('\n', ' '));
            textBox.Paste();
            Clipboard.SetText(s);
        }

        private void CommandTextBox_Load(object sender, EventArgs e)
        {
            MT_Handle = this.Handle;
        }
    }
}