using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.IO;
using System.Runtime.InteropServices;
using System.Collections.Specialized;
using Microsoft.VisualBasic.FileIO;

namespace LControl
{
	public delegate void FileDoubleClickDele(object sender,FileDoubleClickArgs e);
    public partial class FileBrowser : UserControl
    {
        private CmpType CmpType;
        private bool FileOnly;

        private ArrayList FileOpeMenuList;

        private ItemInfo[] FileList;
        bool IsCut;

        bool _ShowHiddenFile=false;
        bool HandleSelIndexChanged = true;
        bool HandleFolderAfterSelect=true;

        private string _RootText="";
        private LPath _RootPath = new LPath("");
        private string _CurrentPath = "";
        private NodeKind RootNodeKind = NodeKind.Computer;

		[Browsable(true), Category("Ϊ"), Description("ѡ·ʱ")]
		public event FileDoubleClickDele FileDoubleClick;

        public FileBrowser()
        {
            if (System.Threading.Thread.CurrentThread.CurrentCulture.LCID == 0x0804)
                LControl_Language.Culture = new System.Globalization.CultureInfo("zh-CN");
            else
                LControl_Language.Culture = new System.Globalization.CultureInfo("en-US");

			InitializeComponent();

			Image16.Images.Add(LResource.file16);
			Image16.Images.Add(LResource.folder16);
			Image16.Images.Add(LResource.disk16);
			Image16.Images.Add(LResource.computer16);

			Image32.Images.Add(LResource.file32);
			Image32.Images.Add(LResource.folder32);
			Image32.Images.Add(LResource.disk32);

			Image48.Images.Add(LResource.file48);
			Image48.Images.Add(LResource.folder48);
			Image48.Images.Add(LResource.disk48);

            InitLanguage();

            FileView.Visible = false;
            DriveView.Visible = false;
            CmpType = CmpType.Wildcard;
            FileOnly = true;
            FileOpeMenuList = new ArrayList();

            this.toolStrip1.Resize += new EventHandler(this.ToolBar_Resize);

            this.FileView.KeyDown += new KeyEventHandler(this.FileView_KeyDown);

            //Filter¼
            Filter.KeyUp+=new KeyEventHandler(Filter_KeyUp);
            Filter.KeyDown+=new KeyEventHandler(Filter_KeyDown);

            //FileView¼
            FileView.DoubleClick += new EventHandler(FileView_DoubleClick);
            FileView.MouseUp += new MouseEventHandler(FileView_MouseUp);
            FileView.DragDrop += new DragEventHandler(FileView_DrapDrop);
            FileView.DragLeave += new EventHandler(FileView_DragLeave);
            FileView.ColumnClick += new ColumnClickEventHandler(FileView_ColumnClick);
            FileView.DragOver += new DragEventHandler(FileView_DrapOver);

			FileView.ListViewItemSorter = new FileViewItemCompare(0, SortOrder.Ascending);
			DriveView.ListViewItemSorter = new DriveViewComparer(0,SortOrder.Ascending);

            DriveView.ColumnClick += new ColumnClickEventHandler(DriveView_ColumnClick);
            DriveView.DoubleClick += new EventHandler(DriveView_DoubleClick);

            cbPath.SelectionChangeCommitted+=new EventHandler(cbPath_SelectionChangeCommitted);
            cbPath.DropDown+=new EventHandler(cbPath_DropDown);
            cbPath.KeyUp+=new KeyEventHandler(cbPath_KeyUp);
            cbPath.KeyDown+=new KeyEventHandler(cbPath_KeyDown);

            Folder.GetAllDriveDele = new GetAllDriveDelegate(this.GetDrives);
            Folder.GetSubDirectoryDele = new GetSubDirectoryDelegate(this.GetSubDirectorys);
        }

        private void InitLanguage()
        {
            DriveView.Groups[0].Header = LControl_Language.strDriveView_Fixed;
            DriveView.Groups[1].Header = LControl_Language.strDriveView_Removable;
            this.DriveName.Text = LControl_Language.strDriveView_Name;
            this.Drive_Type.Text = LControl_Language.strType;
            this.DirveTotalSize.Text = LControl_Language.strTotalSize;
            this.DriveTotalFreeSize.Text = LControl_Language.strTotalFreeSize;

			FileView.Groups[0].Header = LControl_Language.strFile;
			FileView.Groups[1].Header = LControl_Language.strFolder;
            this.FileName.Text = LControl_Language.strFileView_Name;
            this.FileKind.Text = LControl_Language.strType;
            this.FileSize.Text = LControl_Language.strFileView_Size;

            this.Menu_Copy.Text = LControl_Language.strMenu_Copy;
            this.Menu_CopyTo.Text = LControl_Language.strMenu_CopyTo;
            this.Menu_Cut.Text = LControl_Language.strMenu_Cut;
            this.Menu_MoveTo.Text = LControl_Language.strMenu_MoveTo;
            this.Menu_Paste.Text = LControl_Language.strMenu_Paste;
            this.Menu_Delete.Text = LControl_Language.strMenu_Delete;
            this.Menu_Refresh.Text = LControl_Language.strMenu_Refresh;
            this.Menu_NewFolder.Text = LControl_Language.strMenu_NewFolder;

            this.Btn_CopyTo.Text = LControl_Language.strTB_CopyTo;
            this.Btn_CopyTo.ToolTipText = LControl_Language.strTB_CopyTo;
            this.Btn_MoveTo.Text = LControl_Language.strTB_MoveTo;
            this.Btn_MoveTo.ToolTipText = LControl_Language.strTB_MoveTo;
            this.Btn_Upwards.Text = LControl_Language.strTB_Upward;
            this.Btn_Upwards.ToolTipText = LControl_Language.strTB_Upward;
            this.Btn_Delete.Text = LControl_Language.strTB_Delete;
            this.Btn_Delete.ToolTipText = LControl_Language.strTB_Delete;
            this.Btn_Refresh.Text = LControl_Language.strTB_Refresh;
            this.Btn_Refresh.ToolTipText = LControl_Language.strTB_Refresh;
            this.Open_Folder.Text = LControl_Language.strTB_Folder;
            this.Open_Folder.ToolTipText = LControl_Language.strTB_Folder;
            this.Btn_GoTo.Text = LControl_Language.strTB_GoTo;
            this.Btn_GoTo.ToolTipText = LControl_Language.strTB_GoTo;


            this.toolStripLabel1.Text = LControl_Language.strTB_Filter;
            this.toolStripLabel1.ToolTipText = LControl_Language.strTB_Filter;
            this.FilterOption.Text = LControl_Language.strTB_Property;
            this.FilterOption.ToolTipText = LControl_Language.strTB_Property;
            this.toolStripSplitButton1.Text = LControl.LControl_Language.strTB_View;
            this.toolStripSplitButton1.ToolTipText = LControl.LControl_Language.strTB_View;
            this.Menu_View_Details.Text = LControl_Language.strTM_Detail;
            this.Menu_View_List.Text = LControl_Language.strTM_List;
            this.Menu_View_Icon.Text = LControl_Language.strTM_Icon;
        }

        private void FileView_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
            case Keys.Delete:
                {
                    ItemInfo[] SrcFiles = new ItemInfo[FileView.SelectedItems.Count];
                    int i = 0;
                    foreach (ListViewItem lvi in FileView.SelectedItems) SrcFiles[i++] = new ItemInfo((ItemInfo)lvi.Tag);
                    try
                    {
                        Delete(SrcFiles);
                        RefreshCurrentDirectory();
                    }
                    catch (Exception exc)
                    {
                        MessageBox.Show(this, exc.Message, LControl_Language.strErrCap);
                    }
                    break;
                }
            default:
                {
                    break;
                }
            }
        }
        
        private void Menu_View_Icon_Click(object sender, EventArgs e)
        {
            if(FileView.Visible) this.FolderViewMode = View.LargeIcon;
            if(DriveView.Visible) this.DriveViewMode = View.LargeIcon;
        }

        private void Menu_View_List_Click(object sender, EventArgs e)
        {
			if (FileView.Visible) this.FolderViewMode = View.List;
			if (DriveView.Visible) this.DriveViewMode = View.List;
        }

        private void Menu_View_Details_Click(object sender, EventArgs e)
        {
			if (FileView.Visible) this.FolderViewMode = View.Details;
			if (DriveView.Visible) this.DriveViewMode = View.Details;
        }

        private void Menu_View_Tile_Click(object sender, EventArgs e)
        {
			if (FileView.Visible) this.FolderViewMode = View.Tile;
			if (DriveView.Visible) this.DriveViewMode = View.Tile;
        }

        private void FileView_ColumnClick(object sender, ColumnClickEventArgs e)
        {
            try
			{
				if (((FileViewItemCompare)FileView.ListViewItemSorter).Sorting == SortOrder.Ascending)
				{
					FileView.ListViewItemSorter = new FileViewItemCompare(e.Column, SortOrder.Descending);
				}
				else
				{
					FileView.ListViewItemSorter = new FileViewItemCompare(e.Column, SortOrder.Ascending);
				}
				FileView.ShowGroups = false;
				FileView.ShowGroups = true;
            }
            catch (Exception exc)
            {
                MessageBox.Show(this, exc.Message, LControl_Language.strErrCap);
            }
        }

        private void FileView_DoubleClick(object sender, EventArgs e)
        {
            if (FileView.FocusedItem != null)
            {
                try
                {
                    ItemInfo info = (ItemInfo)FileView.FocusedItem.Tag;

					if (info.Type == FileType.Folder)
					{
						CurrentPath = ((LDirectoryInfo)info.Info).FullName;
					}
					else
					{
						OnFileDoubleClick((LFileInfo)((ItemInfo)FileView.FocusedItem.Tag).Info);
						if (FileDoubleClick != null) FileDoubleClick(this, new FileDoubleClickArgs((LFileInfo)((ItemInfo)FileView.FocusedItem.Tag).Info));
					}
                }
                catch (Exception ex)
                {
                    MessageBox.Show(this, ex.Message, LControl_Language.strErr1);
                }
            }
        }

        private void FileView_MouseUp(object sender, MouseEventArgs e)
        {
            if (FileView.SelectedItems.Count != 0)
            {
                Btn_CopyTo.Enabled = true;
                Btn_MoveTo.Enabled = true;
                Btn_Delete.Enabled = true;
            }
            else
            {
                Btn_CopyTo.Enabled = false;
                Btn_MoveTo.Enabled = false;
                Btn_Delete.Enabled = false;
            }
            if (e.Button == MouseButtons.Right)
            {
                if (FileView.SelectedItems.Count == 0)
                {
                    Menu_CopyTo.Enabled = false;
                    Menu_MoveTo.Enabled = false;
                    Menu_Delete.Enabled = false;
                    Menu_Copy.Enabled = false;
                    Menu_Cut.Enabled = false;
					Menu_Rename.Enabled = false;
					Menu_Properties.Enabled = false;
                    foreach (ToolStripItem item in FileOpeMenuList) item.Enabled = false;
                }
                else
                {
                    Menu_CopyTo.Enabled = true;
                    Menu_MoveTo.Enabled = true;
                    Menu_Delete.Enabled = true;
                    Menu_Copy.Enabled = true;
					Menu_Cut.Enabled = true;
					Menu_Rename.Enabled = true;
					Menu_Properties.Enabled = true;
                    foreach (ToolStripItem item in FileOpeMenuList) item.Enabled = true;
                }
                if (FileList==null || FileList.Length == 0) Menu_Paste.Enabled = false; else Menu_Paste.Enabled = true;
                Point p = FileView.PointToScreen(new Point(e.X, e.Y));
                Menu_FileOpe.Show(p.X, p.Y);
            }
        }

        private void FileView_DrapOver(object sender,DragEventArgs e)
        {
            if (e.Data.GetDataPresent("FileDrop"))
            {
                e.Effect = DragDropEffects.Copy;
            }
        }
        
        private void FileView_DragLeave(object sender, EventArgs e)
        {
        }

        private void FileView_DrapDrop(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent("FileDrop"))
            {
                try
                {
                    string[] Files = (string[])e.Data.GetData("FileDrop");
                    DrapFiles(Files);
                    RefreshCurrentDirectory();
                }
                catch (Exception exc)
                {
                    MessageBox.Show(this, exc.Message, LControl_Language.strFolder);
                }
            }
        }

        private void DriveView_DoubleClick(object sender, EventArgs e)
        {
            if (DriveView.FocusedItem != null)
            {
                try
                {
                    CurrentPath = DriveView.FocusedItem.Name + "\\";
                }
                catch (Exception ex)
                {
                    MessageBox.Show(this,ex.Message,LControl_Language.strErr1);
                }
            }
        }

        private void DriveView_ColumnClick(object sender, ColumnClickEventArgs e)
        {
			if (((DriveViewComparer)DriveView.ListViewItemSorter).Sorting == SortOrder.Ascending)
			{
				DriveView.ListViewItemSorter = new DriveViewComparer(e.Column, SortOrder.Descending);
			}
			else
			{
				DriveView.ListViewItemSorter = new DriveViewComparer(e.Column, SortOrder.Ascending);
			}
            DriveView.ShowGroups = false;
            DriveView.ShowGroups = true;
        }

        private void Btn_Upwards_Click(object sender, EventArgs e)
        {
            try
            {
                Upward();
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, LControl_Language.strErrCap);
            }
        }

        private void FilterOption_Click(object sender, EventArgs e)
        {
            Filter newfilter = new Filter(CmpType,FileOnly);
            newfilter.GetFilterOption((IWin32Window)this, ref CmpType, ref FileOnly);
            RefreshCurrentDirectory();
        }

        private void Filter_KeyUp(object sender, KeyEventArgs e)
        {
            try
            {
                if (e.KeyCode == Keys.Enter)
                {
                    e.Handled = true;
                    RefreshCurrentDirectory();
                }
            }
            catch (Exception exc)
            {
                MessageBox.Show(this, exc.Message, LControl_Language.strErrCap);
            }
        }

        private void Filter_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                e.Handled = true;
                e.SuppressKeyPress = true;
            }
        }

        private void Upward()
        {
            LPath path = new LPath(_CurrentPath);
            while (true)
            {
                if (_RootPath.IsParent(path))
                {
                    path.Upward();
                    try
                    {
                        CurrentPath = path.Path;
                        break;
                    }
                    catch (Exception)
                    {
                    }
                }
                else
                    throw new Exception(LControl_Language.strRefreshErr);
            }
        }

        private void Btn_MoveTo_Click(object sender, EventArgs e)
        {
            ItemInfo[] SrcFiles = new ItemInfo[FileView.SelectedItems.Count];
            int i = 0;
            foreach (ListViewItem lvi in FileView.SelectedItems) SrcFiles[i++] = new ItemInfo((ItemInfo)lvi.Tag);
            MoveTo(SrcFiles);
            RefreshCurrentDirectory();
        }

        private void Btn_CopyTo_Click(object sender, EventArgs e)
        {
            ItemInfo[] SrcFiles = new ItemInfo[FileView.SelectedItems.Count];
            int i = 0;
            foreach (ListViewItem lvi in FileView.SelectedItems) SrcFiles[i++] = new ItemInfo((ItemInfo)lvi.Tag);
            CopyTo(SrcFiles);
        }

        private void Btn_Delete_Click(object sender, EventArgs e)
        {
            ItemInfo[] SrcFiles = new ItemInfo[FileView.SelectedItems.Count];
            int i = 0;
            foreach (ListViewItem lvi in FileView.SelectedItems) SrcFiles[i++] = new ItemInfo((ItemInfo)lvi.Tag);
            try
            {
                Delete(SrcFiles);
                RefreshCurrentDirectory();
            }
            catch (Exception exc)
            {
                MessageBox.Show(this, exc.Message, LControl_Language.strErrCap);
            }
        }

        private void Menu_Custom_Click(object sender, EventArgs e)
        {
            ItemInfo[] SrcFiles = new ItemInfo[FileView.SelectedItems.Count];
            int i = 0;
            foreach (ListViewItem lvi in FileView.SelectedItems) SrcFiles[i++] = new ItemInfo((ItemInfo)lvi.Tag);
            CustomOperation(sender,SrcFiles);
        }

        private void Menu_CopyTo_Click(object sender, EventArgs e)
        {
            ItemInfo[] SrcFiles = new ItemInfo[FileView.SelectedItems.Count];
            int i = 0;
            foreach (ListViewItem lvi in FileView.SelectedItems) SrcFiles[i++] = new ItemInfo((ItemInfo)lvi.Tag);
            CopyTo(SrcFiles);
        }

        private void Menu_MoveTo_Click(object sender, EventArgs e)
        {
            ItemInfo[] SrcFiles = new ItemInfo[FileView.SelectedItems.Count];
            int i = 0;
            foreach (ListViewItem lvi in FileView.SelectedItems) SrcFiles[i++] = new ItemInfo((ItemInfo)lvi.Tag);
            MoveTo(SrcFiles);
            RefreshCurrentDirectory();
        }

        private void Menu_Delete_Click(object sender, EventArgs e)
        {
            ItemInfo[] SrcFiles = new ItemInfo[FileView.SelectedItems.Count];
            int i = 0;
            foreach (ListViewItem lvi in FileView.SelectedItems) SrcFiles[i++] = new ItemInfo((ItemInfo)lvi.Tag);
            try
            {
                Delete(SrcFiles);
                RefreshCurrentDirectory();
            }
            catch (Exception exc)
            {
                MessageBox.Show(this, exc.Message, LControl_Language.strErrCap);
            }
        }

        private void Menu_Refresh_Click(object sender, EventArgs e)
        {
            try
            {
                RefreshCurrentDirectory();
            }
            catch (Exception Excep)
            {
                MessageBox.Show(this, Excep.Message, LControl_Language.strErrCap);
            }
        }

        private void Btn_Refresh_Click(object sender, EventArgs e)
        {
            try
            {
                RefreshCurrentDirectory();
            }
            catch (Exception Excep)
            {
                MessageBox.Show(this, Excep.Message, LControl_Language.strErrCap);
            }
        }

        private void RefreshDropDownList()
        {
            try
            {
                cbPath.Items.Clear();

                if (RootNodeKind == NodeKind.Computer)
                {
                    cbPath.Items.Add(new ComboBoxExItem(0, _RootText, _RootPath.Path, 3, _RootPath.Path));
                    LPath cpath = new LPath(_CurrentPath);
                    LPathNode[] pns = cpath.Nodes;

                    LDriveInfo[] dis;
                    GetDrives(out dis);
                    foreach (LDriveInfo ldi in dis)
                    {
                        cbPath.Items.Add(new ComboBoxExItem(10, ldi.VolumeLabel + "(" + ldi.Name.Remove(2) + ")", ldi.Name, 2, ldi.Name));
                        if (pns.Length > 0 && string.Compare(ldi.Name.Remove(2), pns[0].Value, true) == 0)
                        {
                            int retr = 20;
                            int i = 1;
                            for (i = 1; i < pns.Length; i++, retr += 10)
                            {
                                cbPath.Items.Add(new ComboBoxExItem(retr, pns[i].Value, pns[i].FullPath, 1, pns[i].FullPath));
                            }
                        }
                    }
                }
                else
                {
                    cbPath.Items.Add(new ComboBoxExItem(0, _RootText, _RootPath.Path, 1, _RootPath.Path));
                    LPath cpath = new LPath(_CurrentPath);
                    LPathNode[] pns = cpath.Nodes;

                    LDirectoryInfo[] dis;

                    GetSubDirectorys(_RootPath.Path, out dis);

                    foreach (LDirectoryInfo ldi in dis)
                    {
                        cbPath.Items.Add(new ComboBoxExItem(10, ldi.Name, ldi.FullName, 1, ldi.FullName));
                        if (pns.Length > _RootPath.Length && String.Compare(ldi.Name, pns[_RootPath.Length].Value, true) == 0)
                        {
                            int retr = 20;
                            int i;
                            for (i = _RootPath.Length + 1; i < pns.Length; i++, retr += 10)
                            {
                                cbPath.Items.Add(new ComboBoxExItem(retr, pns[i].Value, pns[i].FullPath, 1, pns[i].FullPath));
                            }
                        }
                    }
                }
            }
            catch (Exception)
            {
            }
        }

        private void Open_Folder_Click(object sender, EventArgs e)
        {
            this.HandleFolderAfterSelect = false;
            try
            {
                if (this.Open_Folder.Checked)
                {
                    this.splitter1.Visible = true;
                    this.Folder.Visible = true;
                    this.Folder.SelectedPath = _CurrentPath;
                }
                else
                {
                    this.Folder.Visible = false;
                    this.splitter1.Visible = false;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, LControl_Language.strErr1);
            }
            this.HandleFolderAfterSelect = true;
        }

        private void Menu_NewFolder_Click(object sender, EventArgs e)
        {
            FolderNameDialog fnd = new FolderNameDialog();
            if (fnd.ShowDialog(this) == DialogResult.OK)
            {
                try
                {
                    CreateDirectory(_CurrentPath + "\\" + fnd.FolderName);
                    RefreshCurrentDirectory();
                }
                catch (Exception exc)
                {
                    MessageBox.Show(this, exc.Message, LControl_Language.strErrCap);
                }
            }
        }

        private void Menu_Cut_Click(object sender, EventArgs e)
        {
            FileList = new ItemInfo[FileView.SelectedItems.Count];
            int i = 0;
            foreach (ListViewItem lvi in FileView.SelectedItems) FileList[i++] = new ItemInfo((ItemInfo)lvi.Tag);
            IsCut = true;
        }

        private void Menu_Copy_Click(object sender, EventArgs e)
        {
            FileList = new ItemInfo[FileView.SelectedItems.Count];
            int i = 0;
            foreach (ListViewItem lvi in FileView.SelectedItems) FileList[i++] = new ItemInfo((ItemInfo)lvi.Tag);
            IsCut = false;
        }

        private void Menu_Paste_Click(object sender, EventArgs e)
        {
            Paste(FileList, _CurrentPath, IsCut);
        }

        private void ToolBar_Resize(object sender, System.EventArgs e)
        {
            if (this.Btn_GoTo.Bounds.Left - this.toolStripSplitButton1.Bounds.Right >= 25)
            {
                this.cbPath.Left = this.toolStripSeparator4.Bounds.Right + 1;
                this.cbPath.Width = this.Btn_GoTo.Bounds.Left - this.toolStripSeparator4.Bounds.Right - 2;
                this.cbPath.Visible = true;
            }
            else
                this.cbPath.Visible = false;
        }

        private void cbPath_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (HandleSelIndexChanged && cbPath.SelectedItem != null)
            {
                try
                {
                    CurrentPath = (string)((ComboBoxExItem)cbPath.SelectedItem).Tag;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(this, ex.Message, LControl_Language.strErr1);
                }
            }
        }

        private void cbPath_SelectionChangeCommitted(object sender, EventArgs e)
        {
        }

        private void cbPath_DropDown(object sender, EventArgs e)
        {
            try
            {
                RefreshDropDownList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, LControl_Language.strErrCap);
            }
        }

        private void cbPath_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                e.Handled = true;
                e.SuppressKeyPress = true;
                try
                {
                    CurrentPath = cbPath.Text;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(this, ex.Message, LControl_Language.strErrCap);
                }
            }
        }

        private void cbPath_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                e.Handled = true;
                e.SuppressKeyPress = true;
            }
        }

        private void SetcbPathText(string text)
        {
            HandleSelIndexChanged = false;
            try
            {
                cbPath.Text = text;
            }
            catch (Exception)
            {
            }
            HandleSelIndexChanged = true;
        }

        private void SetCurrentPath(NodeKind kind, LPath rPath, LPath Path)
        {
            try
            {
                DisplayFiles(kind, rPath, Path);
                _CurrentPath = Path.Path;

                SetcbPathText(_CurrentPath);

                this.HandleFolderAfterSelect = false;
                if (Folder.Visible) Folder.SelectedPath = _CurrentPath;
                this.HandleFolderAfterSelect = true;

                if (rPath.IsParent(Path))
                    this.Btn_Upwards.Enabled = true;
                else
                    this.Btn_Upwards.Enabled = false;
            }
            catch (Exception)
            {
                SetcbPathText(_CurrentPath);
                throw;
            }
        }

        private void DisplayFiles(NodeKind kind, LPath rPath, LPath Path)
        {
            if (kind == NodeKind.Computer && Path == rPath)
            {
                try
                {
                    LDriveInfo[] Drives;
                    GetDrives(out Drives);

                    DriveView.Visible = true;
                    FileView.Visible = false;
                    DriveView.Items.Clear();
                    string[] infostr = new string[4];
                    string group = "";

                    foreach (LDriveInfo Drive in Drives)
                    {
                        infostr[0] = Drive.VolumeLabel + " (" + Drive.Name.Remove(2) + ")";
                        infostr[1] = LDriveInfo.DriveTypeToString(Drive.DriveType);
                        if (Drive.DriveType == DriveType.Fixed)
                        {
                            decimal size;
                            size = (decimal)Drive.TotalSize / (1024 * 1024 * 1024);
                            infostr[2] = size.ToString("##0.0#") + " GB";
                            size = (decimal)Drive.TotalFreeSpace / (1024 * 1024 * 1024);
                            infostr[3] = size.ToString("##0.0#") + " GB";
                            group = "Local";
                        }
                        else
                        {
                            infostr[2] = "";
                            infostr[3] = "";
                            group = "Removable";
                        }
						ListViewItem NewItem = null;
						if (DriveView.View != View.Tile)
						{
							NewItem = new ListViewItem(infostr, DriveView.Groups[group]);
						}
						else
						{
							NewItem = new ListViewItem(infostr[0], DriveView.Groups[group]);
						}
                        NewItem.ImageIndex = 2;
                        NewItem.Tag = Drive;
                        Drive.Name = Drive.Name.Remove(2);
                        NewItem.Name = Drive.Name;
                        DriveView.Items.Add(NewItem);
                    }

                }
                catch (Exception)
                {
                    throw;
                }
            }
            else if (Path == rPath || rPath.IsParent(Path))
            {
                try
                {
                    LDirectoryInfo[] Dirs;
                    LFileInfo[] Files;
                    GetDirectionsAndFiles(Path.Path, Filter.Text, out Dirs, out Files);

                    FileView.Visible = true;
                    DriveView.Visible = false;
                    string[] infostr = new string[3];
                    FileView.Items.Clear();

					FileView.SuspendLayout();
                    if (Dirs != null)
                    {
                        bool AddToFileView;
                        foreach (LDirectoryInfo di in Dirs)
                        {
                            AddToFileView = true;
                            try
                            {
                                if (Filter.Text != "" && !FileOnly &&
                                        (CmpType == CmpType.None && di.Name != Filter.Text ||
                                          CmpType == CmpType.Wildcard && !Wildcard.CompareString(di.Name, Filter.Text) ||
                                          CmpType == CmpType.RegularExp && !Regex.IsMatch(di.Name, Filter.Text)) ||
                                          _ShowHiddenFile == false && (di.Attributes & FileAttributes.Hidden) == FileAttributes.Hidden
                                    )
                                    AddToFileView = false;
                                else
                                    AddToFileView = true;
                            }
                            catch (Exception)
                            {
                            }

                            if (AddToFileView)
                            {
								ListViewItem NewItem = null;
								if (FileView.View != View.Tile)
								{
									infostr[0] = di.Name;
									infostr[1] = LControl_Language.strFolder;
									infostr[2] = "";
									NewItem = new ListViewItem(infostr, FileView.Groups[1]);
								}
								else
									NewItem = new ListViewItem(di.Name, FileView.Groups[1]);
                                NewItem.ImageIndex = 1;
                                NewItem.Tag = new ItemInfo(FileType.Folder, di);
                                NewItem.Name = di.Name;
                                FileView.Items.Add(NewItem);
                            }
                        }
                    }
                    if (Files != null)
                    {
                        bool AddToFileView;
                        foreach (LFileInfo fi in Files)
                        {
                            AddToFileView = true;
                            try
                            {
                                if (Filter.Text != "" &&
                                        (CmpType == CmpType.None && fi.Name != Filter.Text ||
                                          CmpType == CmpType.Wildcard && !Wildcard.CompareString(fi.Name, Filter.Text) ||
                                          CmpType == CmpType.RegularExp && !Regex.IsMatch(fi.Name, Filter.Text)) ||
                                          _ShowHiddenFile == false && (fi.Attributes & FileAttributes.Hidden) == FileAttributes.Hidden
                                    )
                                    AddToFileView = false;
                                else
                                    AddToFileView = true;
                            }
                            catch (Exception)
                            {
                            }

                            if (AddToFileView)
                            {
								ListViewItem NewItem = null;
								if (FileView.View != View.Tile)
								{
									infostr[0] = fi.Name;
									infostr[1] = LControl_Language.strFile;
									long size = fi.Length / 1024;
									if (size == 0) size = 1;
									infostr[2] = size.ToString("###,###,##0") + " KB";
									NewItem = new ListViewItem(infostr, FileView.Groups[0]);
								}
								else
								{
									NewItem = new ListViewItem(fi.Name, FileView.Groups[0]);
								}
                                NewItem.ImageIndex = 0;
                                NewItem.Tag = new ItemInfo(FileType.File, fi);
                                NewItem.Name = fi.Name;
                                FileView.Items.Add(NewItem);
                            }
                        }
                    }
					FileView.ResumeLayout();
                }
                catch (Exception)
                {
                    throw;
                }
            }
            else
                throw new PathNotFoundException(LControl_Language.strInvalidPath);
        }

        private void Folder_AfterSelect(object sender, FolderBrowserEventArgs e)
        {
            if (this.HandleFolderAfterSelect)
            {
                try
                {
                    CurrentPath = e.Path;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(this, ex.Message, LControl_Language.strErr1);
                }
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            if (this.DesignMode == false)
            {
                CurrentPath = _CurrentPath;
            }
            base.OnLoad(e);
        }

        #region з˵

        /// <summary>
        ///Զļ˵Ҽ˵
        ///:
        ///menu[in]:Զļ˵Ĳ˵
        ///˵:
        ///Զļ˵,ûò˵ʱ,CustomOperation
        ///ǰѡеļļΪݸCustomOperation
        ///,Զļ˵ʱ,дCustomOperation
        /// </summary>
        public void AddCustomFileOperationMenu(ContextMenuStrip menu)
        {
            ToolStripItem[] items = new ToolStripItem[menu.Items.Count];
            menu.Items.CopyTo(items, 0);
            Menu_FileOpe.Items.AddRange(items);
            FileOpeMenuList.AddRange(items);
            foreach (ToolStripMenuItem item in items)
            {
                item.Click += new EventHandler(Menu_Custom_Click);
            }
        }

        /// <summary>
        ///Զ˵Ҽ˵
        ///:
        ///menu[in]:Զļ˵Ĳ˵
        /// </summary>
        public void AddCustomMenu(ContextMenuStrip menu)
        {
            ToolStripItem[] items = new ToolStripItem[menu.Items.Count];
            menu.Items.CopyTo(items, 0);
            foreach (ToolStripItem item in items)
                Menu_FileOpe.Items.Insert(Menu_FileOpe.Items.IndexOf(Menu_FileOpe.Items["Menu_Separator1"]), item);
        }


        /// <summary>
        ///ָʾתťµĿݲ˵
        /// </summary>
        [Browsable(true), Description("ָʾתťµĿݲ˵"), Category("")]
        public ToolStripDropDown GoToMenu
        {
            get
            {
                return Btn_GoTo.DropDown;
            }
            set
            {
                Btn_GoTo.DropDown = value;
            }
        }

        /// <summary>
        ///ˢµǰĿ¼,ˢʧ,תһĿ¼
        /// </summary>
        public void RefreshCurrentDirectory()
        {
            try
            {
                DisplayFiles(RootNodeKind, _RootPath, new LPath(_CurrentPath));
            }
            catch (Exception e)
            {
                MessageBox.Show(this, e.Message, LControl_Language.strErrCap);
                try
                {
                    Upward();
                }
                catch (Exception e1)
                {
                    MessageBox.Show(this, e1.Message, LControl_Language.strErrCap);
                }
            }
        }

        /// <summary>
        ///õǰ·
        ///쳣:
        ///Exception
        ///GetDirsAndFilesException
        ///GetDriveException
        /// </summary>
        [Browsable(true), Description("õǰĿ¼"), Category("")]
        public string CurrentPath
        {
            get
            {
                return _CurrentPath;
            }
            set
            {
                if (value != null)
                {
                    LPath path;

                    if (value == "")
                        path = _RootPath;
                    else
                        path = new LPath(value);

                    if (this.DesignMode)
                    {
                        if (_RootPath!=path && !_RootPath.IsParent(path))
                        {
                            throw new Exception(LControl_Language.strDesignTip1);
                        }
                    }
                    else
                    {
                        if (this.Created) SetCurrentPath(RootNodeKind, _RootPath, path);
                    }
                    _CurrentPath = path.Path;
                }
            }
        }

        [Browsable(true), Description("Ƿʾļ"), Category("")]
        public bool ShowHiddenFile
        {
            get
            {
                return _ShowHiddenFile;
            }
            set
            {
                Folder.ShowHiddenDir = value;
                _ShowHiddenFile = value;
                if (this.Created && !this.DesignMode) RefreshCurrentDirectory();
            }
        }

        [Browsable(true), Description("Ŀ¼"), Category("")]
        protected string RootText
        {
            get
            {
                return _RootText;
            }
            set
            {
                _RootText = value;
                Folder.RootText = _RootText;
            }
        }

        [Browsable(true), Description("·"), Category("")]
        protected string RootPath
        {
            get
            {
                return _RootPath.Path;
            }
            set
            {
                if (this.Created && !this.DesignMode)
                {
                    NodeKind kind;
                    if (value == "")
                        kind = NodeKind.Computer;
                    else
                        kind = NodeKind.Folder;

                    LPath rpath = new LPath(value);

                    SetCurrentPath(kind, rpath, rpath);
                    Folder.RootPath = value;

                    _RootPath = rpath;
                    RootNodeKind = kind;
                }
                else
                {
                    _RootPath = new LPath(value);
                    if (value == "")
                        RootNodeKind = NodeKind.Computer;
                    else
                        RootNodeKind = NodeKind.Folder;
                }
            }
        }

		[Browsable(true), Description("ļʽ"), Category("")]
		public View FolderViewMode
		{
			get
			{
				return FileView.View;
			}
			set
			{
				if (value != FileView.View)
				{
					if (value == View.Tile)
						FileView.LargeImageList = Image48;
					else
						FileView.LargeImageList = Image32;
					FileView.View = value;
					if (this.Created && !this.DesignMode)
					{
						if (FileView.ListViewItemSorter != null && value == View.Tile) ((FileViewItemCompare)FileView.ListViewItemSorter).Column = 0;
						RefreshCurrentDirectory();
					}
				}
			}
		}

		[Browsable(true), Description("ʽ"), Category("")]
		public View DriveViewMode
		{
			get
			{
				return DriveView.View;
			}
			set
			{
				if (value != DriveView.View)
				{
					if (value == View.Tile)
						DriveView.LargeImageList = Image48;
					else
						DriveView.LargeImageList = Image32;
					DriveView.View = value;
					if (this.Created && !this.DesignMode)
					{
						if (DriveView.ListViewItemSorter != null && value == View.Tile) ((DriveViewComparer)DriveView.ListViewItemSorter).Column = 0;
						RefreshCurrentDirectory();
					}
				}
			}
		}
        #endregion

        #region ҪʵFileBrowser,дº(дûຯ)

        /// <summary>
        ///ϵ߼
        ///ֵLDriveInfo飬ʾϵ߼
        ///д˵
        ///(1)Ŀ¼Ϊҵĵʱ,д÷
        ///(2)ȡ߼ʧʱ׳쳣GetDrivesException
        /// </summary>
        protected virtual void GetDrives(out LDriveInfo[] di)
        {
            di = null;
        }

        //ָĿ¼Ŀ¼ļ ͨDirsfiles
        //д˵
        //(1)д÷
        //(2)ȡĿ¼ļʧʱ׳쳣GetDirAndFileException
        //:
        //(1)path[in]:ҪȡĿ¼ϢĿ¼·;
        //(2)filter[in]:ɸѡַ
        //(3)Dirs[out]:ڷĿ¼
        //(4)Files[out]:ڷļ
        protected virtual void GetDirectionsAndFiles(string path, string filter, out LDirectoryInfo[] Dirs, out LFileInfo[] Files)
        {
            Dirs = null;
            Files = null;
        }

        //ָĿ¼Ŀ¼ͨDirs(Ŀ¼)
        //д˵
        //(1)д÷
        //(2)ȡĿ¼ļʧʱ׳쳣GetSubDirsException
        //:
        //(1)path[in]:ҪȡĿ¼ϢĿ¼·;
        //(2)filter[in]:ɸѡַ
        //(3)Dirs[out]:ڷĿ¼
        protected virtual void GetSubDirectorys(string path, out LDirectoryInfo[] Dirs)
        {
            Dirs = null;
        }


        //Ŀ¼
        //д˵
        //ʧʱҪ(Ҳ)׳쳣
        //:
        //name[in]:ûļ·(ȫ·)
        protected virtual void CreateDirectory(string name)
        {
        }

        //ճļ
        //д˵
        //ʧʱҪ(Ҳ)׳쳣
        //:
        //(1)Files[in]:ǰѡеļļ
        //   ItemInfo.Type==Fileʱ,ItemInfo.InfoΪLFileInfo,ʾļϢ
        //   ItemInfo.Type==Folderʱ,ItemInfo.InfoΪLDirectoryInfo,ʾļеϢ
        //(2)path[in]:Ŀļ
        //(3)cut[in]:
        //   cut=trueʱ,Ϊ
        //   cut=falseʱ,Ϊ
        protected virtual void Paste(ItemInfo[] SrcFiles, string path, bool cut)
        {
        }

        //ƶļ
        //д˵
        //ʧʱҪ(Ҳ)׳쳣
        //:
        //Files[in]:ǰѡеļļ
        //ItemInfo.Type==Fileʱ,ItemInfo.InfoΪLFileInfo,ʾļϢ
        //ItemInfo.Type==Folderʱ,ItemInfo.InfoΪLDirectoryInfo,ʾļеϢ
        protected virtual void MoveTo(ItemInfo[] Files)
        {
        }

        //ļ
        //д˵
        //ʧʱҪ(Ҳ)׳쳣
        //:
        //Files[in]:ǰѡеļļ
        //ItemInfo.Type==Fileʱ,ItemInfo.InfoΪLFileInfo,ʾļϢ
        //ItemInfo.Type==Folderʱ,ItemInfo.InfoΪLDirectoryInfo,ʾļеϢ
        protected virtual void CopyTo(ItemInfo[] Files)
        {
        }

        //ɾļ
        //д˵
        //ʧʱҪ(Ҳ)׳쳣
        //:
        //Files[in]:ǰѡеļļ
        //ItemInfo.Type==Fileʱ,ItemInfo.InfoΪLFileInfo,ʾļϢ
        //ItemInfo.Type==Folderʱ,ItemInfo.InfoΪLDirectoryInfo,ʾļеϢ
        protected virtual void Delete(ItemInfo[] Files)
        {
        }

        //ԶĲ˵ʱ,øúд
        //д˵
        //ʧʱҪ(Ҳ)׳쳣
        //:
        //Files[in]:ǰѡеļļ
        //ItemInfo.Type==Fileʱ,ItemInfo.InfoΪLFileInfo,ʾļϢ
        //ItemInfo.Type==Folderʱ,ItemInfo.InfoΪLDirectoryInfo,ʾļеϢ
        protected virtual void CustomOperation(object sender, ItemInfo[] Files)
        {
        }

        //˫ļʱø÷д
        //д˵
        //ʧʱҪ(Ҳ)׳쳣
        //:
        //file[in],˫ļϢ
        protected virtual void OnFileDoubleClick(LFileInfo file)
        {
        }

        //϶ļؼʱ,ø÷д
        //д˵
        //ʧʱҪ(Ҳ)׳쳣
        //:
        //Files[in]:϶ļļ
        protected virtual void DrapFiles(string[] Files)
        {
        }

		protected virtual void RenameFile(LFileInfo fi,string name)
		{
		}

		protected virtual void RenameDirectory(LDirectoryInfo di, string name)
		{
		}

		protected virtual void GetProperties(string[] Files)
		{
		}
        #endregion

        private void Btn_GoTo_ButtonClick(object sender, EventArgs e)
        {
            try
            {
                CurrentPath = cbPath.Text;
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, LControl_Language.strErr1);
            }
        }

		private void Menu_Rename_Click(object sender, EventArgs e)
		{
		}

		private void FileView_AfterLabelEdit(object sender, LabelEditEventArgs e)
		{
			if (e.Label != null && e.Label != "" && e.Label != FileView.SelectedItems[0].Name)
			{
				try
				{
					ItemInfo item = FileView.SelectedItems[0].Tag as ItemInfo;
					if (item.Type == FileType.Folder)
						RenameDirectory((LDirectoryInfo)item.Info, e.Label);
					else
						RenameFile((LFileInfo)item.Info, e.Label);
					RefreshCurrentDirectory();
				}
				catch (Exception ex)
				{
					MessageBox.Show(this, ex.Message, LControl_Language.strErr1);
				}
				e.CancelEdit = true;
			}
			else
			{
				e.CancelEdit = true;
			}
		}

		private void Menu_Properties_Click(object sender, EventArgs e)
		{
			string[] files=new string[FileView.SelectedItems.Count];
			int i=0;
			foreach (ListViewItem lvi in FileView.SelectedItems)
			{
				if (((ItemInfo)lvi.Tag).Type == FileType.File)
				{
					files[i] = ((LFileInfo)((ItemInfo)lvi.Tag).Info).FullName;
				}
				else
				{
					files[i] = ((LDirectoryInfo)((ItemInfo)lvi.Tag).Info).FullName;
				}
				i++;
			}
			GetProperties(files);
		}
    }

    public enum NodeKind : int
    {
        Computer = 0,
        Drive = 1,
        Folder = 2
    }

    public enum FileType
    {
        Folder,
        File
    }

    public class ItemInfo
    {
        //Type==Fileʱ,InfoΪLFileInfo
        //Type==Folderʱ,InfoΪLDirecotryInfo
        public FileType Type;
        public object Info;
        public ItemInfo(FileType type, object info)
        {
            Type = type;
            Info = info;
        }
        public ItemInfo(ItemInfo item)
        {
            Type = item.Type;
            if (Type == FileType.Folder)
                Info = new LDirectoryInfo((LDirectoryInfo)item.Info);
            else
                Info = new LFileInfo((LFileInfo)item.Info);
        }
    }

    //˵System.IO.DriveInfo
    public class LDriveInfo
    {
        public DriveType DriveType;
        public string Name;
        public DirectoryInfo RootDirectory;
        public long AvailableFreeSpace;
        public string DriveFormat;
        public bool IsReady;
        public long TotalSize;
        public long TotalFreeSpace;
        public string VolumeLabel;

        public LDriveInfo(string name, string volume, string format, DriveType dt, bool ready, DirectoryInfo rootdir, long afs, long ts, long tfs)
        {
            this.Name = name;
            this.VolumeLabel = volume;
            this.DriveFormat = format;
            this.DriveType = dt;
            this.IsReady = ready;
            this.RootDirectory = rootdir;
            this.AvailableFreeSpace = afs;
            this.TotalSize = ts;
            this.TotalFreeSpace = tfs;
        }

        public LDriveInfo(DriveInfo di)
        {
            Name = di.Name;
            DriveType = di.DriveType;
            RootDirectory = di.RootDirectory;
            if (di.DriveType == DriveType.Fixed && di.IsReady)
            {
                AvailableFreeSpace = di.AvailableFreeSpace;
                DriveFormat = di.DriveFormat;
                IsReady = true;
                TotalFreeSpace = di.TotalFreeSpace;
                TotalSize = di.TotalSize;
                if (di.VolumeLabel != "")
                    VolumeLabel = di.VolumeLabel;
                else
                    VolumeLabel = LControl_Language.strDriveType1;
            }
            else
            {
                AvailableFreeSpace = 0;
                DriveFormat = "";
                IsReady = false;
                TotalFreeSpace = 0;
                TotalSize = 0;
                if (di.Name == "A:\\")
                    VolumeLabel = LControl_Language.strDriveType7;
                else
                    VolumeLabel = DriveTypeToString(di.DriveType);
            }
        }

        public static string DriveTypeToString(DriveType type)
        {
            switch (type)
            {
            case DriveType.Fixed:
                return LControl_Language.strDriveType1;
            case DriveType.Removable:
                return LControl_Language.strDriveType2;
            case DriveType.CDRom:
                return LControl_Language.strDriveType3;
            case DriveType.Network:
                return LControl_Language.strDriveType4;
            case DriveType.Ram:
                return LControl_Language.strDriveType5;
            default:
                return LControl_Language.strDriveType6;
            }
        }
    }
    
    //˵System.IO.DirectoryInfo
    public class LDirectoryInfo
    {
        public FileAttributes Attributes;
        public DateTime CreationTime;
        public DateTime CreationTimeUtc;
        public string Extension;
        public string FullName;
        public DateTime LastAccessTime;
        public DateTime LastAccessTimeUtc;
        public DateTime LastWriteTime;
        public DateTime LastWriteTimeUtc;

        public bool Exists;
        public string Name;

        public DirectoryInfo Parent;
        public DirectoryInfo Root;

        public LDirectoryInfo(DirectoryInfo di)
        {
            Attributes = di.Attributes;
            CreationTime = di.CreationTime;
            CreationTimeUtc = di.CreationTimeUtc;
            Extension = di.Extension;
            FullName = di.FullName;
            LastAccessTime = di.LastAccessTime;
            LastAccessTimeUtc = di.LastAccessTimeUtc;
            LastWriteTime = di.LastWriteTime;
            LastWriteTimeUtc = di.LastWriteTimeUtc;

            Exists = di.Exists;
            Name = di.Name;

            Parent = di.Parent;
            Root = di.Root;
        }
        public LDirectoryInfo(LDirectoryInfo ldi)
        {
            Attributes = ldi.Attributes;
            CreationTime = ldi.CreationTime;
            CreationTimeUtc = ldi.CreationTimeUtc;
            Extension = ldi.Extension;
            FullName = ldi.FullName;
            LastAccessTime = ldi.LastAccessTime;
            LastAccessTimeUtc = ldi.LastAccessTimeUtc;
            LastWriteTime = ldi.LastWriteTime;
            LastWriteTimeUtc = ldi.LastWriteTimeUtc;

            Exists = ldi.Exists;
            Name = ldi.Name;

            Parent = ldi.Parent;
            Root = ldi.Root;
        }
        public LDirectoryInfo(FileAttributes attr, DateTime lat, DateTime lwt, DateTime cte, string name, string fullname)
        {
            Attributes = attr;
            LastAccessTime = lat;
            LastWriteTime = lwt;
            CreationTime = cte;
            Name = name;
            FullName = fullname;
        }
    }
    
    //˵System.IO.FileInfo
    public class LFileInfo
    {
        public FileAttributes Attributes;
        public DateTime CreationTime;
        public DateTime CreationTimeUtc;
        public string Extension;
        public string FullName;
        public DateTime LastAccessTime;
        public DateTime LastAccessTimeUtc;
        public DateTime LastWriteTime;
        public DateTime LastWriteTimeUtc;

        public bool Exists;
        public string Name;

        public DirectoryInfo Directory;
        public string DirectoryName;
        public bool IsReadOnly;
        public long Length;

        public LFileInfo(FileInfo fi)
        {
            Attributes = fi.Attributes;
            CreationTime = fi.CreationTime;
            CreationTimeUtc = fi.CreationTimeUtc;
            Extension = fi.Extension;
            FullName = fi.FullName;
            LastAccessTime = fi.LastAccessTime;
            LastAccessTimeUtc = fi.LastAccessTimeUtc;
            LastWriteTime = fi.LastWriteTime;
            LastWriteTimeUtc = fi.LastWriteTimeUtc;

            Exists = fi.Exists;
            Name = fi.Name;

            Directory = fi.Directory;
            DirectoryName = fi.DirectoryName;
            Length = fi.Length;
            IsReadOnly = fi.IsReadOnly;
        }
        public LFileInfo(LFileInfo lfi)
        {
            Attributes = lfi.Attributes;
            CreationTime = lfi.CreationTime;
            CreationTimeUtc = lfi.CreationTimeUtc;
            Extension = lfi.Extension;
            FullName = lfi.FullName;
            LastAccessTime = lfi.LastAccessTime;
            LastAccessTimeUtc = lfi.LastAccessTimeUtc;
            LastWriteTime = lfi.LastWriteTime;
            LastWriteTimeUtc = lfi.LastWriteTimeUtc;

            Exists = lfi.Exists;
            Name = lfi.Name;

            Directory = lfi.Directory;
            DirectoryName = lfi.DirectoryName;
            Length = lfi.Length;
            IsReadOnly = lfi.IsReadOnly;
        }
        public LFileInfo(FileAttributes attr, DateTime lat, DateTime lwt, DateTime cte, long length, string name, string fullname)
        {
            Attributes = attr;
            LastAccessTime = lat;
            LastWriteTime = lwt;
            CreationTime = cte;
            Length = length;
            Name = name;
            FullName = fullname;
        }
    }

    public enum CmpType
    {
        Wildcard,
        RegularExp,
        None
    }

    public class Wildcard
    {
        public static bool CompareString(string str, string Pattern)
        {
            int istr, ip;
            istr = 0;
            ip = 0;
            while (istr < str.Length && ip < Pattern.Length)
            {
                if (Pattern[ip] == '*')
                {
                    int ncp = ip + 1;
                    while (ncp < Pattern.Length && Pattern[ncp] == '*') ncp++;
                    if (ncp == Pattern.Length) return true;
                    while (istr < str.Length && !CompareChar(str[istr], Pattern[ncp])) istr++;
                    if (istr == str.Length) return false;
                    ip = ncp + 1;
                    istr++;
                }
                else
                {
                    if (!CompareChar(str[istr++], Pattern[ip++])) return false;
                }
            }
            if (istr == str.Length && ip == Pattern.Length) return true; else return false;
        }
        private static bool CompareChar(char c, char cp)
        {
            switch (cp)
            {
            case '#':
                if (c < '0' || c > '9') return false; else return true;
            case '?':
                if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z'))
                    return true;
                else
                    return false;
            default:
                if (c == cp ||
                    c >= 'a' && c <= 'z' && c == cp + 'a' - 'A' ||
                    c >= 'A' && c <= 'Z' && cp == c + 'a' - 'A')
                    return true;
                else
                    return false;
            }
        }
    }

    public class DriveViewComparer : IComparer
    {
        private int ColumnIndex;
        SortOrder Order;
        public DriveViewComparer(int Index, SortOrder order)
        {
            this.ColumnIndex = Index;
            this.Order = order;
		}
		public SortOrder Sorting
		{
			get { return Order; }
			set { Order = value; }
		}
		public int Column
		{
			get { return Column; }
			set { ColumnIndex = value; }
		}

        public int Compare(object Item1, object Item2)
        {
            LDriveInfo ldi1, ldi2;
            ldi1 = (LDriveInfo)((ListViewItem)Item1).Tag;
            ldi2 = (LDriveInfo)((ListViewItem)Item2).Tag;
            switch (ColumnIndex)
            {
            case 0:
                {
                    if (Order == SortOrder.Ascending)
                        return String.Compare(ldi1.Name, ldi2.Name);
                    else
                        return -String.Compare(ldi1.Name, ldi2.Name);
                }
            case 1:
                return 0;
            case 2:
                {
                    int res;
                    if (ldi1.TotalSize > ldi2.TotalSize)
                        res = 1;
                    else if (ldi1.TotalSize == ldi2.TotalSize)
                        res = 0;
                    else
                        res = -1;
                    if (Order == SortOrder.Ascending) return res; else return -res;
                }
            case 3:
                {
                    int res;
                    if (ldi1.TotalFreeSpace > ldi2.TotalFreeSpace)
                        res = 1;
                    else if (ldi1.TotalFreeSpace == ldi2.TotalFreeSpace)
                        res = 0;
                    else
                        res = -1;
                    if (Order == SortOrder.Ascending) return res; else return -res;
                }
            default:
                return 0;
            }
        }
    }

    public class FileViewItemCompare : IComparer
    {
        int ColumnIndex;
        SortOrder Order;
        public FileViewItemCompare(int Index, SortOrder order)
        {
            ColumnIndex = Index;
            Order = order;
        }
		public SortOrder Sorting
		{
			get { return Order; }
			set { Order = value; }
		}
		public int Column
		{
			get { return Column; }
			set { ColumnIndex = value; }
		}

        public int Compare(Object item1, Object item2)
        {
			ListViewItem Item1 = item1 as ListViewItem;
			ListViewItem Item2 = item2 as ListViewItem;
			if (((ItemInfo)Item1.Tag).Type == ((ItemInfo)Item2.Tag).Type)
			{
				switch (ColumnIndex)
				{
				case 2:
					{
						long res;
						ItemInfo info;
						info = (ItemInfo)((ListViewItem)Item1).Tag;
						if (info.Type == FileType.File)
							res = ((LFileInfo)info.Info).Length;
						else
							res = 0;
						info = (ItemInfo)((ListViewItem)Item2).Tag;
						if (info.Type == FileType.File) res -= ((LFileInfo)info.Info).Length;
						if (Order == SortOrder.Ascending) return (int)res; else return -(int)res;
					}
				default:
					if (Order == SortOrder.Ascending)
						return String.Compare(((ListViewItem)Item1).SubItems[ColumnIndex].Text, ((ListViewItem)Item2).SubItems[ColumnIndex].Text);
					else
						return -String.Compare(((ListViewItem)Item1).SubItems[ColumnIndex].Text, ((ListViewItem)Item2).SubItems[ColumnIndex].Text);
				}
			}
			else
			{
				if (((ItemInfo)Item1.Tag).Type == FileType.Folder) return 1; else return -1;
			}
        }
    }

    public class PathNotFoundException : Exception
    {
        public PathNotFoundException(string msg)
            : base(msg)
        {
        }
    }

    public class GetDirsAndFilesException : Exception
    {
        public GetDirsAndFilesException(string msg)
            : base(msg)
        {
        }
    }

    public class GetDriveException : Exception
    {
        public GetDriveException(string msg)
            : base(msg)
        {
        }
    }

    public class GetSubDirsException : Exception
    {
        public GetSubDirsException(string msg)
            : base(msg)
        {
        }
    }

	public class FileDoubleClickArgs : EventArgs
	{
		private LFileInfo _fi;
		public LFileInfo fi
		{
			get { return _fi; }
		}
		public FileDoubleClickArgs(LFileInfo info)
		{
			_fi = info;
		}
	}
}
