using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace LControl
{
    public partial class LocalFolderBrowser : LControl.FolderBrowser
    {
        public LocalFolderBrowser()
        {
            InitializeComponent();
        }

        protected override void GetAllDrive(out LDriveInfo[] ldis)
        {
            try
            {
                DriveInfo[] dis = DriveInfo.GetDrives();
                ldis = new LDriveInfo[dis.Length];
                int i = 0;
                foreach (DriveInfo di in dis)
                {
                    ldis[i] = new LDriveInfo(di);
                    i++;
                }
            }
            catch (Exception ioe)
            {
                throw new GetDriveException(ioe.Message);
            }
        }

        protected override void GetSubDirectory(string path, out LDirectoryInfo[] Dirs)
        {
            try
            {
                DirectoryInfo[] dis = null;

                DirectoryInfo pdi = new DirectoryInfo(path);
                dis = pdi.GetDirectories();

                Dirs = new LDirectoryInfo[dis.Length];

                int i = 0;
                foreach (DirectoryInfo di in dis) Dirs[i++] = new LDirectoryInfo(di);
            }
            catch (Exception Error)
            {
                Dirs = null;
                throw new GetDirsAndFilesException(Error.Message);
            }
        }
    }
}
